   (DEFUN CONNLISTS (LAMBDA (GRAPH)
   ; GRAPH -     ᬥ              ;
   ; : ᯨ᮪ ᯨ᪮ 設  吝 ;
      (CONNLSTS GRAPH NIL)
   ))
   ; --------------------------------- ;
   (DEFUN CONNLSTS (LAMBDA (GRAPH LISTS)
      (COND ( (NULL GRAPH) LISTS )
            ( T (COND ( (NULL (LMEMBER (CAAR GRAPH) LISTS))
                           (CONNLSTS
                               (CDR GRAPH)
                               (CONS (DEPTHFIRST
                                         GRAPH
                                         (CAAR GRAPH))
                                     LISTS)
                           )
                      )
                      (  T  (CONNLSTS (CDR GRAPH) LISTS) )
                )
            )
      )
   ))
   ; --------------------------------- ;
   (DEFUN LMEMBER (LAMBDA (VERTEX LISTS)
   ; ஢, ᮤন  設 VERTEX  - ;
   ;           ᯨ᪮, ⠢ LISTS              ;
      (AND
          LISTS
          (OR (MEMBER  VERTEX (CAR LISTS))
              (LMEMBER VERTEX (CDR LISTS))
          )
      )
   ))
   ; ---------------------------------- ;
   (DEFUN DEPTHFIRST (LAMBDA (GRAPH ROOT)
   ; GRAPH -     ᬥ              ;
   ; ROOT  - 設 ,  ன 稭     ;
   ; : ᯨ᮪ 設   浪 宦 ;
      (COND ( (NULL GRAPH) NIL )
            (  T  (DEFI GRAPH (LIST ROOT) (LIST ROOT)) )
      )
   ))
   ; ------------------------------------ ;
   (DEFUN DEFI (LAMBDA (GRAPH VISITED PATH)
   ; VISITED - ᯨ᮪ 㦥 ᬮ७ 設         ;
   ; PATH - ᯨ᮪ 設, ।  ᬮ ;
      (COND ( (NULL PATH) (REVERSE VISITED) )
            ( T  (COND ( (NULL (EXPND GRAPH VISITED (CAR PATH)))
                            (DEFI GRAPH
                                  VISITED
                                  (CDR PATH))
                       )
                       (  T  (DEFI GRAPH
                                   (CONS (EXPND GRAPH VISITED
                                                (CAR PATH))
                                         VISITED)
                                   (CONS (EXPND GRAPH VISITED
                                                (CAR PATH))
                                         PATH))
                       )
                 )
            )
      )
   ))
   ; --------------------------------------- ;
   (DEFUN EXPND (LAMBDA (GRAPH VISITED VERTEX)
   ; 롮 ᫥饩   ᬮ७ 設, ;
   ;               ᥤ  VERTEX               ;
      (COND ( (NULL (NEIGHBOUR3 VERTEX GRAPH)) NIL )
            (  T  (FIRSTNOTVISITED
                             VISITED
                             (NEIGHBOUR3 VERTEX GRAPH))
            )
      )
   ))
   ; ------------------------------------------ ;
   (DEFUN FIRSTNOTVISITED (LAMBDA (VISITED VLIST)
      (COND ( (NULL VLIST) NIL )
            (  T  (COND ( (NULL (MEMBER (CAR VLIST) VISITED))
                             (CAR VLIST) )
                        (  T  (FIRSTNOTVISITED
                                           VISITED
                                           (CDR VLIST)) )
                  )
            )
      )
   ))
   ; ------------------------------- ;
   (DEFUN NEIGHBOUR3 (LAMBDA (X GRAPH)
      (COND ( (NULL (ASSOC X GRAPH)) NIL )
            (  T  (CDR (ASSOC X GRAPH)) )
      )
   ))
(RDS)